'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _createDecoratedClass = (function () { function defineProperties(target, descriptors, initializers) { for (var i = 0; i < descriptors.length; i++) { var descriptor = descriptors[i]; var decorators = descriptor.decorators; var key = descriptor.key; delete descriptor.key; delete descriptor.decorators; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor || descriptor.initializer) descriptor.writable = true; if (decorators) { for (var f = 0; f < decorators.length; f++) { var decorator = decorators[f]; if (typeof decorator === 'function') { descriptor = decorator(target, key, descriptor) || descriptor; } else { throw new TypeError('The decorator for method ' + descriptor.key + ' is of the invalid type ' + typeof decorator); } } if (descriptor.initializer !== undefined) { initializers[key] = descriptor; continue; } } Object.defineProperty(target, key, descriptor); } } return function (Constructor, protoProps, staticProps, protoInitializers, staticInitializers) { if (protoProps) defineProperties(Constructor.prototype, protoProps, protoInitializers); if (staticProps) defineProperties(Constructor, staticProps, staticInitializers); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _clsIsoflux = require('cls-isoflux');

var _clsIsoflux2 = _interopRequireDefault(_clsIsoflux);

var _marty = require('marty');

var _overrideDecorator = require('override-decorator');

var _overrideDecorator2 = _interopRequireDefault(_overrideDecorator);

var IsoMarty = (function (_Isoflux) {
  function IsoMarty() {
    _classCallCheck(this, IsoMarty);

    if (_Isoflux != null) {
      _Isoflux.apply(this, arguments);
    }

    this._registrations = [];
    this.app = this.createProxy(_marty.Application);
  }

  _inherits(IsoMarty, _Isoflux);

  _createDecoratedClass(IsoMarty, [{
    key: 'createApp',
    decorators: [_overrideDecorator2['default']],
    value: function createApp() {
      var marty = new _marty.Application();
      this._registerObjects(marty);

      return marty;
    }
  }, {
    key: '_registerObjects',
    value: function _registerObjects(marty) {
      this._registrations.forEach(function (Class) {
        return marty.register(Class.name, Class);
      });
    }
  }, {
    key: 'register',
    value: function register(Class) {
      this._registrations.push(Class);
      return this.createProxy(Class);
    }
  }, {
    key: '_getProxiedObject',
    decorators: [_overrideDecorator2['default']],
    value: function _getProxiedObject(Class) {
      var marty = this.getApp();

      if (Class === _marty.Application) {
        return marty;
      } else {
        return marty[Class.name];
      }
    }
  }]);

  return IsoMarty;
})(_clsIsoflux2['default']);

exports['default'] = IsoMarty;
module.exports = exports['default'];